# -*- coding: utf-8 -*-
#!/usr/bin/env python

# These two lines are only needed if you don't put the script directly into
# the installation directory
import sys
reload(sys)
sys.setdefaultencoding("utf-8")
sys.path.append('/usr/share/inkscape/extensions')

import inkex, simplestyle, tempfile, os, re

class ExportTIFF(inkex.Effect):
    def __init__(self):
        inkex.Effect.__init__(self)
        self.OptionParser.add_option("-r", "--resolution", action="store", type="string", dest="resolution", default="300", help="resolution da Imagem")
        self.OptionParser.add_option("-k", "--set_overprint_black", action="store", type="inkbool", dest="set_overprint_black", default=True, help="Sobrepor o preto")
        self.OptionParser.add_option("-g", "--set_overprint_black_gradient", action="store", type="inkbool", dest="set_overprint_black_gradient", default=True, help="Sobrepor o preto nos gradientes")
        self.OptionParser.add_option("-s", "--set_overprint_black_stroke", action="store", type="inkbool", dest="set_overprint_black_stroke", default=True, help="Sobrepor o preto nos contornos")
        self.OptionParser.add_option("-f", "--set_overprint_black_flood", action="store", type="inkbool", dest="set_overprint_black_flood", default=True, help="Sobrepor o preto nos 'floods'(?)")
        self.OptionParser.add_option("-l", "--set_overprint_black_lighting", action="store", type="inkbool", dest="set_overprint_black_lighting", default=True, help="Sobrepor o preto nos 'lightings'(?)")
        self.OptionParser.add_option("-a", "--set_alpha", action="store", type="inkbool", dest="set_alpha", default=True, help="Manter transparência")
        self.OptionParser.add_option('-m', '--mode', action='store', type='string', dest='mode', help='Processar as 4 cores juntas')

    def effect(self):
        svg = open(self.svg_file, 'r').read()

        def trocar_cores(origin, tipo_cor):
            for i in range(len(str(origin).split(tipo_cor + ':'))):
                if str(str(origin).split(tipo_cor + ':')[i].split(';')[0]) in simplestyle.svgcolors.keys():
                    numeros_da_cor = simplestyle.formatColoria(simplestyle.parseColor(str(str(origin).split(tipo_cor + ':')[i].split(';')[0])))
                    origin = str(origin).replace(':' + str(str(origin).split(tipo_cor + ':')[i].split(';')[0]) + ';', ':' + numeros_da_cor + ';')
            return origin

        colortypes = ['fill', 'stop-color', 'flood-color', 'lighting-color', 'stroke']

        for i in range(len(colortypes)):
            svg = trocar_cores(svg, colortypes[i])

        for i in range(len(svg.split('\n'))):
            if 'sodipodi:docname="' in str(svg).split('\n')[i]:
                file_name = str(svg).split('sodipodi:docname="')[1].split('"')[0][:-4]

        do_win_inkscape = ""
        null_dir = " > /dev/null"

        if os.sep == "\\":
            do_win_inkscape = "c"
            null_dir = ""
            temp_dir = tempfile.gettempdir() + '\\'
        else:
            temp_dir = tempfile.gettempdir() + '/'

        def removeK(origin):
            for i in range(len(origin.split('\n'))):
                if (self.options.set_overprint_black) and '#000000;fill-opacity:' in origin.split('\n')[i]:
                    origin = origin.replace(origin.split('\n')[i], origin.split('\n')[i].replace('fill-opacity:' + origin.split('\n')[i].split('fill-opacity:')[1].split(';')[0].split('"')[0], 'fill-opacity:0'))
                if (self.options.set_overprint_black_gradient) and '#000000;stop-opacity:' in origin.split('\n')[i]:
                    origin = origin.replace(origin.split('\n')[i], origin.split('\n')[i].replace('stop-opacity:' + origin.split('\n')[i].split('stop-opacity:')[1].split(';')[0].split('"')[0], 'stop-opacity:0'))
                if (self.options.set_overprint_black_stroke) and '#000000;stroke-opacity:' in origin.split('\n')[i]:
                    origin = origin.replace(origin.split('\n')[i], origin.split('\n')[i].replace('stroke-opacity:' + origin.split('\n')[i].split('stroke-opacity:')[1].split(';')[0].split('"')[0], 'stroke-opacity:0'))
                if (self.options.set_overprint_black_flood) and '#000000;flood-opacity:' in origin.split('\n')[i]:
                    origin = origin.replace(origin.split('\n')[i], origin.split('\n')[i].replace('flood-opacity:' + origin.split('\n')[i].split('flood-opacity:')[1].split(';')[0].split('"')[0], 'flood-opacity:0'))
                if (self.options.set_overprint_black_lighting) and '#000000;lighting-opacity:' in origin.split('\n')[i]:
                    origin = origin.replace(origin.split('\n')[i], origin.split('\n')[i].replace('lighting-opacity:' + origin.split('\n')[i].split('lighting-opacity:')[1].split(';')[0].split('"')[0], 'lighting-opacity:0'))
            return origin

        def calculateCMYK(red, green, blue):
            C = float()
            M = float()
            Y = float()
            K = float()

            if 1.00 - red < 1.00 - green:
                K = 1.00 - red
            else:
                K = 1.00 - green

            if 1.00 - blue < K:
                K = 1.00 - blue

            if K != 1.00:
                C = ( 1.00 - red   - K ) / ( 1.00 - K )
                M = ( 1.00 - green - K ) / ( 1.00 - K )
                Y = ( 1.00 - blue  - K ) / ( 1.00 - K )

            return [C, M, Y, K]

        def representC(value):
            red =   float(simplestyle.parseColor(str(value.group()))[0]/255.00)
            green = float(simplestyle.parseColor(str(value.group()))[1]/255.00)
            blue =  float(simplestyle.parseColor(str(value.group()))[2]/255.00)
            return simplestyle.formatColor3f(float(1.00 - calculateCMYK(red, green, blue)[0]), float(1.00), float(1.00))

        def representM(value):
            red =   float(simplestyle.parseColor(str(value.group()))[0]/255.00)
            green = float(simplestyle.parseColor(str(value.group()))[1]/255.00)
            blue =  float(simplestyle.parseColor(str(value.group()))[2]/255.00)
            return simplestyle.formatColor3f(float(1.00), float(1.00 - calculateCMYK(red, green, blue)[1]), float(1.00))

        def representY(value):
            red =   float(simplestyle.parseColor(str(value.group()))[0]/255.00)
            green = float(simplestyle.parseColor(str(value.group()))[1]/255.00)
            blue =  float(simplestyle.parseColor(str(value.group()))[2]/255.00)
            return simplestyle.formatColor3f(float(1.00), float(1.00), float(1.00 - calculateCMYK(red, green, blue)[2]))

        def representK(value):
            red =   float(simplestyle.parseColor(str(value.group()))[0]/255.00)
            green = float(simplestyle.parseColor(str(value.group()))[1]/255.00)
            blue =  float(simplestyle.parseColor(str(value.group()))[2]/255.00)
            return simplestyle.formatColor3f(float(1.00 - calculateCMYK(red, green, blue)[3]), float(1.00 - calculateCMYK(red, green, blue)[3]), float(1.00 - calculateCMYK(red, green, blue)[3]))

        resolution = str(int(self.options.resolution))

        if (self.options.set_alpha):
            alpha = " "
            color_space = "CMYKA"
            def get_alpha_mask(origin):
                os.system('convert ' + origin + ' -alpha extract "' + temp_dir + 'mask.png"')
            def set_alpha_mask(origin):
                os.system('composite -compose CopyOpacity "' + temp_dir + 'mask.png" "' + origin + '" "' + origin + '"')
        else:
            alpha = " --export-background=white "
            color_space = "CMYK"

        file_name_c = str(temp_dir + file_name + "_separated-cmyk-c.svg");
        file_name_m = str(temp_dir + file_name + "_separated-cmyk-m.svg");
        file_name_y = str(temp_dir + file_name + "_separated-cmyk-y.svg");
        file_name_k = str(temp_dir + file_name + "_separated-cmyk-k.svg");

        file_name_c_image = str(temp_dir + file_name + "_separated-cmyk-c.png")
        file_name_m_image = str(temp_dir + file_name + "_separated-cmyk-m.png")
        file_name_y_image = str(temp_dir + file_name + "_separated-cmyk-y.png")
        file_name_k_image = str(temp_dir + file_name + "_separated-cmyk-k.png")

        if (self.options.set_overprint_black):
            svgK = re.sub("#[a-fA-F0-9]{6}", representK, svg)
            open(file_name_k,"w").write(svgK)

            os.system('inkscape' + do_win_inkscape + ' -z "' + file_name_k + '" --export-dpi=' + resolution + alpha + ' --export-png="' + file_name_k_image + '"' + null_dir)
            if (self.options.set_alpha):
                    get_alpha_mask(file_name_k_image)
            os.system('convert' + ' "' + file_name_k_image + '" -colorspace CMYK -channel K -negate -separate "' + file_name_k_image + '"')

            if self.options.mode == 'Processar as 4 cores juntas':
                svgCMY = removeK(svg)
                file_name_cmy = str(temp_dir + file_name + "_separated-cmyk-cmy.svg");
                open(file_name_cmy,"w").write(svgCMY)
                file_name_cmy_image = str(temp_dir + file_name + "_separated-cmyk-cmy.png")
                os.system('inkscape' + do_win_inkscape + ' -z "' + file_name_cmy + '" --export-dpi=' + resolution + alpha + ' --export-png="' + file_name_cmy_image + '"' + null_dir)
                os.system('convert' + ' "' + file_name_cmy_image + '" -colorspace CMYK -channel C -separate "' + file_name_c_image + '"')
                os.system('convert' + ' "' + file_name_cmy_image + '" -colorspace CMYK -channel M -separate "' + file_name_m_image + '"')
                os.system('convert' + ' "' + file_name_cmy_image + '" -colorspace CMYK -channel Y -separate "' + file_name_y_image + '"')

            else:
                svgC = re.sub("#[a-fA-F0-9]{6}", representC, removeK(svg))
                svgM = re.sub("#[a-fA-F0-9]{6}", representM, removeK(svg))
                svgY = re.sub("#[a-fA-F0-9]{6}", representY, removeK(svg))

                open(file_name_c,"w").write(svgC)
                open(file_name_m,"w").write(svgM)
                open(file_name_y,"w").write(svgY)
                os.system('inkscape' + do_win_inkscape + ' -z "' + file_name_c + '" --export-dpi=' + resolution + alpha + ' --export-png="' + file_name_c_image + '"' + null_dir)
                os.system('inkscape' + do_win_inkscape + ' -z "' + file_name_m + '" --export-dpi=' + resolution + alpha + ' --export-png="' + file_name_m_image + '"' + null_dir)
                os.system('inkscape' + do_win_inkscape + ' -z "' + file_name_y + '" --export-dpi=' + resolution + alpha + ' --export-png="' + file_name_y_image + '"' + null_dir)

                os.system('convert' + ' "' + file_name_c_image + '" -colorspace CMYK -channel C -separate "' + file_name_c_image + '"')
                os.system('convert' + ' "' + file_name_m_image + '" -colorspace CMYK -channel M -separate "' + file_name_m_image + '"')
                os.system('convert' + ' "' + file_name_y_image + '" -colorspace CMYK -channel Y -separate "' + file_name_y_image + '"')

            os.system('convert' + ' "' + file_name_k_image + '" -negate "' + file_name_k_image + '"')
            os.system('convert' + ' "' + file_name_c_image + '"' + ' "' + file_name_m_image + '"' + ' "' + file_name_y_image + '"' + ' "' + file_name_k_image + '"' + ' -set colorspace CMYK -combine "' + temp_dir + file_name + '.tif"')
            if (self.options.set_alpha):
                set_alpha_mask(temp_dir + file_name + '.tif')

        else:
            if self.options.mode == 'Processar as 4 cores juntas':
                file_name_cmyk = str(temp_dir + file_name + "_separated-cmyk.svg");
                open(file_name_cmyk,"w").write(svg)

                file_name_cmyk_image = str(temp_dir + file_name + "_separated-cmyk.png")
                os.system('inkscape' + do_win_inkscape + ' -z "' + file_name_cmyk + '" --export-dpi=' + resolution + alpha + ' --export-png="' + file_name_cmyk_image + '"' + null_dir)
                os.system('convert' + ' "' + file_name_cmyk_image + '" -negate -set colorspace ' + color_space + ' "' + temp_dir + file_name + '.tif"')
            else:
                svgC = re.sub("#[a-fA-F0-9]{6}", representC, svg)
                svgM = re.sub("#[a-fA-F0-9]{6}", representM, svg)
                svgY = re.sub("#[a-fA-F0-9]{6}", representY, svg)
                svgK = re.sub("#[a-fA-F0-9]{6}", representK, svg)
                open(file_name_c,"w").write(svgC)
                open(file_name_m,"w").write(svgM)
                open(file_name_y,"w").write(svgY)
                open(file_name_k,"w").write(svgK)
                os.system('inkscape' + do_win_inkscape + ' -z "' + file_name_c + '" --export-dpi=' + resolution + alpha + ' --export-png="' + file_name_c_image + '"' + null_dir)
                os.system('inkscape' + do_win_inkscape + ' -z "' + file_name_m + '" --export-dpi=' + resolution + alpha + ' --export-png="' + file_name_m_image + '"' + null_dir)
                os.system('inkscape' + do_win_inkscape + ' -z "' + file_name_y + '" --export-dpi=' + resolution + alpha + ' --export-png="' + file_name_y_image + '"' + null_dir)
                os.system('inkscape' + do_win_inkscape + ' -z "' + file_name_k + '" --export-dpi=' + resolution + alpha + ' --export-png="' + file_name_k_image + '"' + null_dir)
                if (self.options.set_alpha):
                    get_alpha_mask(file_name_k_image)
                os.system('convert' + ' "' + file_name_c_image + '" -colorspace CMYK -channel C -separate "' + file_name_c_image + '"')
                os.system('convert' + ' "' + file_name_m_image + '" -colorspace CMYK -channel M -separate "' + file_name_m_image + '"')
                os.system('convert' + ' "' + file_name_y_image + '" -colorspace CMYK -channel Y -separate "' + file_name_y_image + '"')
                os.system('convert' + ' "' + file_name_k_image + '" -colorspace CMYK -channel K -separate "' + file_name_k_image + '"')

                os.system('convert' + ' "' + file_name_k_image + '" -negate "' + file_name_k_image + '"')
                os.system('convert' + ' "' + file_name_c_image + '"' + ' "' + file_name_m_image + '"' + ' "' + file_name_y_image + '"' + ' "' + file_name_k_image + '"' + ' -set colorspace CMYK -combine "' + temp_dir + file_name + '.tif"')

                if (self.options.set_alpha):
                    set_alpha_mask(temp_dir + file_name + '.tif"')

        out = open(temp_dir + file_name + '.tif','rb')
        if os.name == 'nt':
            try:
                import msvcrt
                msvcrt.setmode(1, os.O_BINARY)
            except:
                pass
        sys.stdout.write(out.read())
        out.close()

effect = ExportTIFF()
effect.affect()
